require('json')
require('dbenv')

db = dbenv:new()
data = json.data()

    function pairsByKeys(t, f)
      local a = {}
      for n in pairs(t) do table.insert(a, n) end
      table.sort(a, f)
      local i = 0      -- iterator variable
      local iter = function ()   -- iterator function
        i = i + 1
        if a[i] == nil then return nil
        else return a[i], t[a[i]]
        end
      end
      return iter
    end

result = { success = false }

if data.type=='event' then
  result.classes = {
    {value = 'Alarm Abort', names = {}},
    {value = 'Alarm Restores', names = {}},
    {value = 'Alarms', names = {}},
    {value = 'Confirmed alarms', names = {}},
    {value = 'Doors', names = {}},
    {value = 'Early / Late', names = {}},
    {value = 'Fault or Tamper Restores', names = {}},
    {value = 'Faults or Tampers', names = {}},
    {value = 'Inhibit and Isolate', names = {}},
    {value = 'Network', names = {}},
    {value = 'Other', names = {}},
    {value = 'Other (Non- Standard)', names = {}},
    {value = 'Setting and Unsetting', names = {}},
    {value = 'Unfiltered', names = {}},
    {value = 'Zone State Changes', names = {}},
  }
  result.success=true
elseif data.type=='command' then
elseif data.type=='status' then
elseif data.type=='user' then
  result.classes = {
    {value = 1, name = 'Christof'},
    {value = 2, name = 'Louis'},
    {value = 3, name = 'Sarah'},
  }
  result.success=true
elseif data.type=='elementURL' then
  local f = io.open('/tmp/gs-storage/spcway_element_html', 'r')
  local datastr = f:read('*all')
  f:close()
  result.url = loadstring('return '..datastr)()
  result.classes = {
--    storage.get('elementInfo')
    tbl = tbl,
    str = datastr,
  }
  result.success=true
elseif data.type=='elementURLold' then
  local f = io.open('/tmp/gs-storage/spcway_element_info', 'r')
  local datastr = f:read('*all')
  f:close()
  local tbl = loadstring('return '..datastr)()
  result.url={}
  rowMax = 16
  for cat, cattbl in pairs(tbl) do
    curRow = 1
    urltbl={}
    for key, val in pairsByKeys(cattbl,function(one,two) if tonumber(one) and tonumber(two) then  do return tonumber(one) < tonumber(two) end else do return one<two end end end) do
      if urltbl[curRow..'']==nil then urltbl[curRow..''] ='' end
      urltbl[curRow..''] = urltbl[curRow..''] .. '<td>' .. key .. ' : ' .. val .. '</td>'
      curRow = curRow + 1
      if curRow>rowMax then curRow=1 end
    end
    catstr  = ''
    for key, val in pairsByKeys(urltbl,function(one,two) if tonumber(one) and tonumber(two) then  do return tonumber(one) < tonumber(two) end else do return one<two end end end) do
      catstr = catstr .. '<tr>' .. val .. '</tr>'
    end
    catstr = '<table>' .. catstr .. '</table>'
    table.insert(result.url, {type = cat, value = catstr})
  end
  result.classes = {
--    storage.get('elementInfo')
    tbl = tbl,
    str = datastr,
  }
  result.success=true
end

json.write(result)
