#!/usr/bin/haserl
Content-Type: text/html; charset=utf-8

<!DOCTYPE html>
<html>
<head>
  <title><? cat /lib/genohm-scada/brand ?></title>
  <meta http-equiv="content-type" content="text/html; charset=utf-8">
  <link rel="stylesheet" type="text/css" href="/scada/blockly/style.css?version=20141127">
  <link rel="stylesheet" type="text/css" href="/scada/resources/codemirror.css?version=20141127">
  <script type="text/javascript" src="/scada/resources/codemirror.js.gz?version=20141127"></script>
</head>
<body class="unselectable">
  <script src="/scada/blockly/blockly.js.gz?version=20141127"></script>
  <script src="/scada/blockly/code.js?version=20141127"></script>

  <input type="file" id="xml-file" class="hide">

  <div id="topbar">
    <div class="buttons" id="buttons-save-close">
      <button class="btn btn-success" id="save">Save</button>
      <button class="btn btn-success" id="save-close">Save and close</button>
      <button class="btn" id="close">Close</button>
    </div>
    <span id="title"></span>
    <button class="btn btn-small btn-info" id="lua-show-hide">Show Lua code</button>
    <button class="btn btn-small" id="xml-save">Save as file</button>
    <button class="btn btn-small" id="xml-load">Load from file</button>
  </div>

  <div id="content-blockly" class="content"></div>
  <div id="content-lua" class="content hide"></div>

  <div class="loading hide"><div></div></div>

  <div id="ac-wrap" class="ac-wrap hide">
    <div class="ac-input-wrap">
      <input type="text" class="ac-input">
      <span class="ac-reset hide">×</span>
    </div>
  </div>

  <xml id="toolbox" class="hide">
    <category name="Objects">
      <block type="grp_event_getvalue"></block>
      <block type="grp_read"></block>
      <block type="grp_write"></block>
      <block type="grp_update"></block>
      <block type="grp_getvalue"></block>
    </category>
    <category name="Storage">
      <block type="storage_get"></block>
      <block type="storage_get_default"></block>
      <block type="storage_set"></block>
    </category>
    <category name="Script control">
      <block type="script_status"></block>
      <block type="script_enable"></block>
      <block type="script_disable"></block>
    </category>
    <category name="Miscellaneous">
      <block type="misc_alert">
        <value name="TEXT">
          <block type="text"></block>
        </value>
      </block>
      <block type="misc_log">
        <value name="VAR">
          <block type="variables_get">
            <title name="VAR">item</title>
          </block>
        </value>
      </block>
      <block type="misc_sleep">
        <value name="VALUE">
          <block type="math_number">
            <title name="NUM">1</title>
          </block>
        </value>
      </block>
      <block type="misc_comment">
        <block type="text"></block>
      </block>
    </category>
    <category name="Logic">
      <block type="controls_if"></block>
      <block type="logic_compare"></block>
      <block type="logic_operation"></block>
      <block type="logic_negate"></block>
      <block type="logic_boolean"></block>
      <block type="logic_null"></block>
      <block type="logic_ternary"></block>
    </category>
    <category name="Loops">
      <block type="controls_repeat_ext">
        <value name="TIMES">
          <block type="math_number">
            <title name="NUM">10</title>
          </block>
        </value>
      </block>
      <block type="controls_whileUntil"></block>
      <block type="controls_for">
        <value name="FROM">
          <block type="math_number">
            <title name="NUM">1</title>
          </block>
        </value>
        <value name="TO">
          <block type="math_number">
            <title name="NUM">10</title>
          </block>
        </value>
        <value name="BY">
          <block type="math_number">
            <title name="NUM">1</title>
          </block>
        </value>
      </block>
      <block type="controls_forEach"></block>
      <block type="controls_flow_statements"></block>
    </category>
    <category name="Math">
      <block type="math_number"></block>
      <block type="math_arithmetic"></block>
      <block type="math_single"></block>
      <block type="math_trig"></block>
      <block type="math_constant"></block>
      <block type="math_number_property"></block>
      <block type="math_change">
        <value name="DELTA">
          <block type="math_number">
            <title name="NUM">1</title>
          </block>
        </value>
      </block>
      <block type="math_round"></block>
      <block type="math_on_list"></block>
      <block type="math_modulo"></block>
      <block type="math_constrain">
        <value name="LOW">
          <block type="math_number">
            <title name="NUM">1</title>
          </block>
        </value>
        <value name="HIGH">
          <block type="math_number">
            <title name="NUM">100</title>
          </block>
        </value>
      </block>
      <block type="math_random_int">
        <value name="FROM">
          <block type="math_number">
            <title name="NUM">1</title>
          </block>
        </value>
        <value name="TO">
          <block type="math_number">
            <title name="NUM">100</title>
          </block>
        </value>
      </block>
      <block type="math_random_float"></block>
    </category>
    <category name="Text">
      <block type="text"></block>
      <block type="text_join"></block>
      <block type="text_append">
        <value name="TEXT">
          <block type="text"></block>
        </value>
      </block>
      <block type="text_length"></block>
      <block type="text_isEmpty"></block>
      <block type="text_indexOf">
        <value name="VALUE">
          <block type="variables_get">
            <title name="VAR">mytext</title>
          </block>
        </value>
      </block>
      <block type="text_charAt">
        <value name="VALUE">
          <block type="variables_get">
            <title name="VAR">mytext</title>
          </block>
        </value>
      </block>
      <block type="text_getSubstring">
        <value name="STRING">
          <block type="variables_get">
            <title name="VAR">mytext</title>
          </block>
        </value>
      </block>
      <block type="text_changeCase"></block>
      <block type="text_trim"></block>
    </category>
    <category name="Lists">
      <block type="lists_create_empty"></block>
      <block type="lists_create_with"></block>
      <block type="lists_repeat">
        <value name="NUM">
          <block type="math_number">
            <title name="NUM">5</title>
          </block>
        </value>
      </block>
      <block type="lists_length"></block>
      <block type="lists_isEmpty"></block>
      <block type="lists_indexOf">
        <value name="VALUE">
          <block type="variables_get">
            <title name="VAR">mylist</title>
          </block>
        </value>
      </block>
      <block type="lists_getIndex">
        <value name="VALUE">
          <block type="variables_get">
            <title name="VAR">mylist</title>
          </block>
        </value>
      </block>
      <block type="lists_add"></block>
      <block type="lists_setIndex">
        <value name="LIST">
          <block type="variables_get">
            <title name="VAR">mylist</title>
          </block>
        </value>
      </block>
      <block type="lists_getSublist">
        <value name="LIST">
          <block type="variables_get">
            <title name="VAR">mylist</title>
          </block>
        </value>
      </block>
    </category>
    <category name="Variables" custom="VARIABLE"></category>
    <? lua /lib/genohm-scada/web/scripting/blockly-user.lua ?>
  </xml>

  <script type="text/javascript">
  $(function() {
    var script, acdata;
    script = <? lua /lib/genohm-scada/web/scripting/form.lua ?>
    acdata = <? lua /lib/genohm-scada/web/scripting/editor.lua ?>

    if (script && script.success) {
      Code.init(script.data, acdata);
    }
    else {
      alert('Script not found');
    }
  });
  </script>
</body>
</html>
