#!/usr/bin/haserl
Content-Type: text/javascript

Scada.Bacnet = {};
$BN = Scada.Bacnet;

$BN.Url = function(fn) {
  return '/cgi-bin/scada/general/bacnet.cgi?fn=' + fn;
};

$BN.onScanComplete = function() {
  $BN.mask.hide();
  $BN.tree.root.reload();
  $BN.store.reload();
};

$BN.scan = function(id) {
  $BN.mask = Ext.Msg.wait('Scanning...', 'Please wait');

  Ext.Ajax.request({
    url: $BN.Url('scan'),
    params: { id: id },
    success: $BN.onScanComplete,
    failure: $BN.onScanComplete
  });
};

$BN.store = new Ext.data.JsonStore({
  url: $BN.Url('objects'),
  root: 'data',
  fields: [ 'id', 'identifier', 'type', 'name', 'present-value', 'priority-array' ]
});

$BN.treePanel = $def.tree({
  id: 'bacnet-tree',
  dataUrl: $BN.Url('devices'),
  margins: '10 0 10 10',
  region: 'west',
  title: 'Devices',
  bbar: [
    {
      xtype: 'button',
      text: 'Scan network',
      handler: function() {
        $BN.scan(0);
      }
    },
    '-',
    {
      xtype: 'button',
      text: 'Scan selected',
      handler: function() {
        if ($BN.devId >= 0) {
          $BN.scan($BN.devId);
        }
        else {
          Ext.Msg.alert('Error', 'No device selected');
        }
      }
    }
  ]
});

$BN.gridPanel = new Ext.grid.GridPanel($def.grid({
  store: $BN.store,
  colModel: new Ext.grid.ColumnModel({
    columns: [
      { header: 'Type', width: .15, dataIndex: 'type' },
      { header: 'ID', width: .10, dataIndex: 'identifier' },
      { header: 'Name', width: .15, dataIndex: 'name' },
      { header: 'Value', width: .10, dataIndex: 'present-value' },
      { header: 'Priority array', width: .50, dataIndex: 'priority-array' }
    ]
  })
}));

$BN.container = new Ext.Container({
  id: 'BACnet',
  title: 'BACnet',
  layout: 'border',
  items: [ $BN.treePanel, $BN.gridPanel ]
});

$BN.init = function() {
  $BN.tree = Ext.getCmp('bacnet-tree');
  $BN.tree.on('click', function(node) {
    var id = node.attributes.id;
    if (id >= 0) {
      $BN.devId = id;
      $BN.store.setBaseParam('id', id);
      $BN.store.load();
    }
  });
};

Scada.Modules.push($BN);
