#!/usr/bin/haserl
Content-Type: text/javascript

Scada.EnoceanEP = {};
var $ENE = Scada.EnoceanEP;

$ENE.store = new Ext.data.JsonStore({
  baseParams: {},
  url: $EN.reqUrl('ep-main'),
  root: 'data',
  fields: [ 'id', 'base', 'active' ]
});

$ENE.grid = new Ext.grid.GridPanel($def.grid({
  id: 'EnoceanEP',
  title: 'Interfaces',
  store: $ENE.store,
  border: false,
  colModel: new Ext.grid.ColumnModel({
    columns: [
      { header: 'ID', width: 0.50, dataIndex: 'id' },
      { header: 'Base address', width: 0.50, dataIndex: 'base' }
    ]
  }),
  viewConfig: {
    forceFit: true,
    getRowClass: function(record) {
      return (record.data.active == '1') ? 'objects-row-normal' : 'objects-row-error';
    }
  },
  bbar: [
    { text: 'Rescan', id: 'enocean-ep-rescan' }, '-',
    { iconCls: 'x-tbar-loading', id: 'enocean-ep-refresh' }
  ]
}));

$ENE.update = function() {
  $ENE.refreshBtn.setDisabled(true);
  $ENE.store.reload();
};

$ENE.onRescanConfirm = function(confirmResult) {
  if (confirmResult == 'yes') {
    Ext.Ajax.request({
      url: $EN.reqUrl('ep-rescan'),
      success: $ENE.update,
      failure: $ENE.update
    });
  }
}

$ENE.init = function() {
  $ENE.reloaderTask = { run: $ENE.update, interval: 10000 };

  $ENE.rescanBtn = Ext.getCmp('enocean-ep-rescan');
  $ENE.refreshBtn = Ext.getCmp('enocean-ep-refresh');

  $ENE.rescanBtn.on('click', function() {
    Ext.Msg.confirm(
      'Rescan',
      'Are you sure you want to restart the EnOcean service to scan for new interfaces?',
      $ENE.onRescanConfirm
    );
  });

  $ENE.refreshBtn.on('click', $ENE.update);

  $ENE.store.on('load', function() {
    $ENE.refreshBtn.setDisabled(false);
  });

  $ENE.update();
};

$EN.modules.push($ENE);
$EN.MainPanel.add($ENE.grid);
