#!/usr/bin/haserl
Content-Type: text/javascript

Scada.Alerts = {};
var $A = Scada.Alerts;

$A.store = new Ext.data.JsonStore({
  url: Scada.reqUrl('alerts'),
  root: 'data',
  fields: [ 'id', 'scriptname', 'alert', 'alerttime' ]
});

$A.pagination = new Ext.PagingToolbar({
  pageSize: Config.perpage,
  store: $A.store,
  displayMsg: $tr('alerts_pages_hint'),
  emptyMsg: $tr('alerts_pages_empty'),
  beforePageText: $tr('page'),
  afterPageText: $tr('page_of'),
  items: [
    { text: $tr('utilities_reset_button'), id: 'reset-alerts', iconCls: 'icon-clear' }, '-'
  ]
});

$A.grid = new Ext.grid.GridPanel($def.grid({
  id: 'alerts-grid',
  store: $A.store,
  bbar: $A.pagination,
  cls: 'x-scada-ns-grid',
  colModel: new Ext.grid.ColumnModel({
    columns: [
      { header: $tr('alerts_time'), width: .15, dataIndex: 'alerttime', xtype: 'timestampcolumn' },
      { header: $tr('errorlog_name'), width: .15, dataIndex: 'scriptname', renderer: Ext.util.Format.htmlEncode },
      { header: $tr('alerts_text'), width: .70, dataIndex: 'alert', renderer: Ext.util.Format.htmlEncode }
    ]
  })
}));

$A.container = new Ext.Container({
  id: 'Alerts',
  title: $tr('alerts_title'),
  layout: 'border',
  items: $A.grid
});

$A.update = function() {
  $A.pagination.doRefresh();
}

$A.init = function() {
  $A.reloaderTask = { run: $A.update, interval: 6000 };
}

Scada.Modules.push($A);
