#!/usr/bin/haserl
Content-Type: text/javascript

Scada.Help = {};
var $H = Scada.Help;

$H.container = new Ext.Container({
  id: 'Help',
  title: $tr('help_title'),
  iconCls: 'scada-help-icon',
  layout: 'hbox',
  layoutConfig: {
    align : 'stretch'
  },
  items: [
    $def.tree({
      id: 'scada-help-tree',
      title: $tr('help_topics'),
      root: {
        children: [
          {
            text: $tr('help_scripting'),
            cls: 'folder',
            expanded: true,
            children: [
              { text: $tr('help_scripting_basics'), leaf: true, cls: 'file', file: 'scripting-basics' },
              { text: $tr('help_scripting_object'), leaf: true, cls: 'file', file: 'scripting-object' },
              { text: $tr('help_scripting_datatype'), leaf: true, cls: 'file', file: 'scripting-datatype' },
              { text: $tr('help_scripting_common'), leaf: true, cls: 'file', file: 'scripting-common' },
              { text: $tr('help_scripting_scheduled'), leaf: true, cls: 'file', file: 'scripting-scheduled' },
              { text: $tr('help_scripting_extended'), leaf: true, cls: 'file', file: 'scripting-extended' }
            ]
          },
          {
            text: $tr('help_about'),
            leaf: true,
            cls: 'file',
            file: 'about'
          }
        ]
      },
      rootVisible: false
    }),
    {
      xtype: 'panel', margins: '10 10 10 0',
      id: 'scada-help-content',
      flex: 1
    }
  ]
});

$H.onFocus = function() {
  if (!$H.loaded) {
    var node = $H.Tree.root.childNodes[ 0 ].childNodes[ 0 ];
    node.fireEvent('click', node);
    $H.loaded = true;
  }
};

$H.init = function() {
  $H.Content = Ext.getCmp('scada-help-content');
  $H.Tree = Ext.getCmp('scada-help-tree');

  $H.Tree.on('click', function(node) {
    var attr = node.attributes;

    if (attr && attr.leaf && attr.file) {
      $H.Content.load('/scada/help/en/' + attr.file + '.html');
    }
    else {
      node.toggle();
    }
  });
};

Scada.Modules.push($H);
